#include <stdio.h>
#include <string.h>

int main(int argc, char *argv[])
{
#define LEN 16
  char a[LEN], b[LEN], c[LEN*2];

#if defined(UNSAFE)
  strcpy(a, "0123456789abcdef");
  strcpy(b, "0123456789abcdef");
  strcpy(c, a);
  strcat(c, b);
#else
  strncpy(a, "0123456789abcdef", sizeof(a)); a[sizeof(a)-1]='\0';
  strncpy(b, "0123456789abcdef", sizeof(b)); b[sizeof(b)-1]='\0';
  strncpy(c, a, sizeof(c)); c[sizeof(c)-1] = '\0';
  strncat(c, b, sizeof(c)-strlen(c)-1);
#endif
  puts(c);
  return 0;
}
